#==================NOTE====================#
# This function was coded by BlueCommander #
# Please don't claim this as your own work #
#   LINK www.youtube.com/c/BlueCommander   #
#==========================================#
#----------------MESSAGES------------------#
tellraw @a ["",{"text":"Guns> ","color":"blue","bold":false},{"text":"Data Pack loaded!","color":"none","bold":false}]
tellraw @a ["",{"text":"Guns> ","color":"blue","bold":false},{"text":"Created by BlueCommander!","color":"none","bold":false}]
tellraw @a ["",{"text":"[Click to get Guns] ","color":"green","clickEvent":{"action":"run_command","value":"/function guns:getguns"}},{"text":"[Click to edit Guns]","color":"red","clickEvent":{"action":"run_command","value":"/function guns:editguns"}}]
#---------------OBJECTIVES-----------------#
scoreboard objectives add Constant dummy
scoreboard objectives add ShootGun minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add GunID dummy
scoreboard objectives add GunIDCool dummy
scoreboard objectives add BulPosX dummy
scoreboard objectives add BulPosZ dummy
scoreboard objectives add BulletFall dummy
scoreboard objectives add BulletSpeedTrack dummy
scoreboard objectives add ReloadGunTrack dummy
scoreboard objectives add ClipAmmoTrack dummy
scoreboard objectives add FireBreakTrack dummy
scoreboard objectives add GunScopeSneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add GunNewBullet dummy
scoreboard objectives add DirectDig dummy
scoreboard objectives add DirectDig2 dummy
scoreboard objectives add DirectRot dummy
scoreboard objectives add DirectRot2 dummy
scoreboard objectives add GunLoreAmmo dummy
scoreboard objectives add GunEditPage dummy
scoreboard objectives add Temp_BulSpeed dummy
scoreboard objectives add Temp_GravTimer dummy
scoreboard objectives add Temp_Reloading dummy
scoreboard objectives add Temp_ClipAmmo dummy
scoreboard objectives add Temp_FireBreak dummy
scoreboard objectives add Temp_Scope dummy
scoreboard objectives add Temp_BulCount dummy
scoreboard objectives add Temp_BulDamage dummy
scoreboard objectives add Temp_Direction dummy
scoreboard players set @a GunEditPage 0
#---------------FORCELOADS-----------------#
forceload remove 29999977 29832
forceload add 29999977 29832
fill 29999976 0 29831 29999979 2 29833 bedrock
#---------------VARIABLES-----------------#
# The bullet speed (Blocks/Second)
scoreboard objectives add GunVar_BulSpeed dummy
execute unless score Gun1 GunVar_BulSpeed matches 0.. run scoreboard players set Gun1 GunVar_BulSpeed 2
execute unless score Gun2 GunVar_BulSpeed matches 0.. run scoreboard players set Gun2 GunVar_BulSpeed 3
execute unless score Gun3 GunVar_BulSpeed matches 0.. run scoreboard players set Gun3 GunVar_BulSpeed 8
execute unless score Gun4 GunVar_BulSpeed matches 0.. run scoreboard players set Gun4 GunVar_BulSpeed 1
execute unless score Gun5 GunVar_BulSpeed matches 0.. run scoreboard players set Gun5 GunVar_BulSpeed 1
execute unless score Gun6 GunVar_BulSpeed matches 0.. run scoreboard players set Gun6 GunVar_BulSpeed 10
execute unless score Gun7 GunVar_BulSpeed matches 0.. run scoreboard players set Gun7 GunVar_BulSpeed 3
execute unless score Gun8 GunVar_BulSpeed matches 0.. run scoreboard players set Gun8 GunVar_BulSpeed 6
execute unless score Gun9 GunVar_BulSpeed matches 0.. run scoreboard players set Gun9 GunVar_BulSpeed 1
execute unless score Gun10 GunVar_BulSpeed matches 0.. run scoreboard players set Gun10 GunVar_BulSpeed 6
execute unless score Gun11 GunVar_BulSpeed matches 0.. run scoreboard players set Gun11 GunVar_BulSpeed 4
execute unless score Gun12 GunVar_BulSpeed matches 0.. run scoreboard players set Gun12 GunVar_BulSpeed 4
execute unless score Gun13 GunVar_BulSpeed matches 0.. run scoreboard players set Gun13 GunVar_BulSpeed 4
execute unless score Gun14 GunVar_BulSpeed matches 0.. run scoreboard players set Gun14 GunVar_BulSpeed 2
execute unless score Gun15 GunVar_BulSpeed matches 0.. run scoreboard players set Gun15 GunVar_BulSpeed 14

# The time until the bullet curves down (Ticks)
scoreboard objectives add GunVar_GravTimer dummy
execute unless score Gun1 GunVar_GravTimer matches 0.. run scoreboard players set Gun1 GunVar_GravTimer 6
execute unless score Gun2 GunVar_GravTimer matches 0.. run scoreboard players set Gun2 GunVar_GravTimer 60
execute unless score Gun3 GunVar_GravTimer matches 0.. run scoreboard players set Gun3 GunVar_GravTimer 300
execute unless score Gun4 GunVar_GravTimer matches 0.. run scoreboard players set Gun4 GunVar_GravTimer 60
execute unless score Gun5 GunVar_GravTimer matches 0.. run scoreboard players set Gun5 GunVar_GravTimer 100
execute unless score Gun6 GunVar_GravTimer matches 0.. run scoreboard players set Gun6 GunVar_GravTimer 250
execute unless score Gun7 GunVar_GravTimer matches 0.. run scoreboard players set Gun7 GunVar_GravTimer 20
execute unless score Gun8 GunVar_GravTimer matches 0.. run scoreboard players set Gun8 GunVar_GravTimer 150
execute unless score Gun9 GunVar_GravTimer matches 0.. run scoreboard players set Gun9 GunVar_GravTimer 175
execute unless score Gun10 GunVar_GravTimer matches 0.. run scoreboard players set Gun10 GunVar_GravTimer 100
execute unless score Gun11 GunVar_GravTimer matches 0.. run scoreboard players set Gun11 GunVar_GravTimer 100
execute unless score Gun12 GunVar_GravTimer matches 0.. run scoreboard players set Gun12 GunVar_GravTimer 45
execute unless score Gun13 GunVar_GravTimer matches 0.. run scoreboard players set Gun13 GunVar_GravTimer 60
execute unless score Gun14 GunVar_GravTimer matches 0.. run scoreboard players set Gun14 GunVar_GravTimer 20
execute unless score Gun15 GunVar_GravTimer matches 0.. run scoreboard players set Gun15 GunVar_GravTimer 250

# The time for a gun to reload clip ammo (Ticks)
scoreboard objectives add GunVar_Reloading dummy
execute unless score Gun1 GunVar_Reloading matches 0.. run scoreboard players set Gun1 GunVar_Reloading 45
execute unless score Gun2 GunVar_Reloading matches 0.. run scoreboard players set Gun2 GunVar_Reloading 20
execute unless score Gun3 GunVar_Reloading matches 0.. run scoreboard players set Gun3 GunVar_Reloading 40
execute unless score Gun4 GunVar_Reloading matches 0.. run scoreboard players set Gun4 GunVar_Reloading 60
execute unless score Gun5 GunVar_Reloading matches 0.. run scoreboard players set Gun5 GunVar_Reloading 80
execute unless score Gun6 GunVar_Reloading matches 0.. run scoreboard players set Gun6 GunVar_Reloading 100
execute unless score Gun7 GunVar_Reloading matches 0.. run scoreboard players set Gun7 GunVar_Reloading 30
execute unless score Gun8 GunVar_Reloading matches 0.. run scoreboard players set Gun8 GunVar_Reloading 80
execute unless score Gun9 GunVar_Reloading matches 0.. run scoreboard players set Gun9 GunVar_Reloading 40
execute unless score Gun10 GunVar_Reloading matches 0.. run scoreboard players set Gun10 GunVar_Reloading 80
execute unless score Gun11 GunVar_Reloading matches 0.. run scoreboard players set Gun11 GunVar_Reloading 50
execute unless score Gun12 GunVar_Reloading matches 0.. run scoreboard players set Gun12 GunVar_Reloading 25
execute unless score Gun13 GunVar_Reloading matches 0.. run scoreboard players set Gun13 GunVar_Reloading 25
execute unless score Gun14 GunVar_Reloading matches 0.. run scoreboard players set Gun14 GunVar_Reloading 30
execute unless score Gun15 GunVar_Reloading matches 0.. run scoreboard players set Gun15 GunVar_Reloading 80

# The ammo in each clip (Bullet Count)
scoreboard objectives add GunVar_ClipAmmo dummy
execute unless score Gun1 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun1 GunVar_ClipAmmo 1
execute unless score Gun2 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun2 GunVar_ClipAmmo 4
execute unless score Gun3 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun3 GunVar_ClipAmmo 1
execute unless score Gun4 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun4 GunVar_ClipAmmo 8
execute unless score Gun5 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun5 GunVar_ClipAmmo 5
execute unless score Gun6 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun6 GunVar_ClipAmmo 3
execute unless score Gun7 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun7 GunVar_ClipAmmo 7
execute unless score Gun8 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun8 GunVar_ClipAmmo 10
execute unless score Gun9 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun9 GunVar_ClipAmmo 30
execute unless score Gun10 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun10 GunVar_ClipAmmo 6
execute unless score Gun11 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun11 GunVar_ClipAmmo 5
execute unless score Gun12 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun12 GunVar_ClipAmmo 3
execute unless score Gun13 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun13 GunVar_ClipAmmo 5
execute unless score Gun14 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun14 GunVar_ClipAmmo 8
execute unless score Gun15 GunVar_ClipAmmo matches 0.. run scoreboard players set Gun15 GunVar_ClipAmmo 1

# The minimum delay between each shot (Ticks)
scoreboard objectives add GunVar_FireBreak dummy
execute unless score Gun1 GunVar_FireBreak matches 0.. run scoreboard players set Gun1 GunVar_FireBreak 0
execute unless score Gun2 GunVar_FireBreak matches 0.. run scoreboard players set Gun2 GunVar_FireBreak 7
execute unless score Gun3 GunVar_FireBreak matches 0.. run scoreboard players set Gun3 GunVar_FireBreak 20
execute unless score Gun4 GunVar_FireBreak matches 0.. run scoreboard players set Gun4 GunVar_FireBreak 0
execute unless score Gun5 GunVar_FireBreak matches 0.. run scoreboard players set Gun5 GunVar_FireBreak 10
execute unless score Gun6 GunVar_FireBreak matches 0.. run scoreboard players set Gun6 GunVar_FireBreak 40
execute unless score Gun7 GunVar_FireBreak matches 0.. run scoreboard players set Gun7 GunVar_FireBreak 20
execute unless score Gun8 GunVar_FireBreak matches 0.. run scoreboard players set Gun8 GunVar_FireBreak 30
execute unless score Gun9 GunVar_FireBreak matches 0.. run scoreboard players set Gun9 GunVar_FireBreak 0
execute unless score Gun10 GunVar_FireBreak matches 0.. run scoreboard players set Gun10 GunVar_FireBreak 4
execute unless score Gun11 GunVar_FireBreak matches 0.. run scoreboard players set Gun11 GunVar_FireBreak 10
execute unless score Gun12 GunVar_FireBreak matches 0.. run scoreboard players set Gun12 GunVar_FireBreak 6
execute unless score Gun13 GunVar_FireBreak matches 0.. run scoreboard players set Gun13 GunVar_FireBreak 5
execute unless score Gun14 GunVar_FireBreak matches 0.. run scoreboard players set Gun14 GunVar_FireBreak 10
execute unless score Gun15 GunVar_FireBreak matches 0.. run scoreboard players set Gun15 GunVar_FireBreak 0

# Does the gun have a scope? (Binary 1/0)
scoreboard objectives add GunVar_Scope dummy
execute unless score Gun1 GunVar_Scope matches 0.. run scoreboard players set Gun1 GunVar_Scope 0
execute unless score Gun2 GunVar_Scope matches 0.. run scoreboard players set Gun2 GunVar_Scope 0
execute unless score Gun3 GunVar_Scope matches 0.. run scoreboard players set Gun3 GunVar_Scope 1
execute unless score Gun4 GunVar_Scope matches 0.. run scoreboard players set Gun4 GunVar_Scope 0
execute unless score Gun5 GunVar_Scope matches 0.. run scoreboard players set Gun5 GunVar_Scope 0
execute unless score Gun6 GunVar_Scope matches 0.. run scoreboard players set Gun6 GunVar_Scope 1
execute unless score Gun7 GunVar_Scope matches 0.. run scoreboard players set Gun7 GunVar_Scope 0
execute unless score Gun8 GunVar_Scope matches 0.. run scoreboard players set Gun8 GunVar_Scope 0
execute unless score Gun9 GunVar_Scope matches 0.. run scoreboard players set Gun9 GunVar_Scope 0
execute unless score Gun10 GunVar_Scope matches 0.. run scoreboard players set Gun10 GunVar_Scope 1
execute unless score Gun11 GunVar_Scope matches 0.. run scoreboard players set Gun11 GunVar_Scope 1
execute unless score Gun12 GunVar_Scope matches 0.. run scoreboard players set Gun12 GunVar_Scope 0
execute unless score Gun13 GunVar_Scope matches 0.. run scoreboard players set Gun13 GunVar_Scope 0
execute unless score Gun14 GunVar_Scope matches 0.. run scoreboard players set Gun14 GunVar_Scope 1
execute unless score Gun15 GunVar_Scope matches 0.. run scoreboard players set Gun15 GunVar_Scope 1

# The amount of bullets per shot (Bullet Count)
scoreboard objectives add GunVar_BulCount dummy
execute unless score Gun1 GunVar_BulCount matches 0.. run scoreboard players set Gun1 GunVar_BulCount 4
execute unless score Gun2 GunVar_BulCount matches 0.. run scoreboard players set Gun2 GunVar_BulCount 1
execute unless score Gun3 GunVar_BulCount matches 0.. run scoreboard players set Gun3 GunVar_BulCount 1
execute unless score Gun4 GunVar_BulCount matches 0.. run scoreboard players set Gun4 GunVar_BulCount 3
execute unless score Gun5 GunVar_BulCount matches 0.. run scoreboard players set Gun5 GunVar_BulCount 1
execute unless score Gun6 GunVar_BulCount matches 0.. run scoreboard players set Gun6 GunVar_BulCount 1
execute unless score Gun7 GunVar_BulCount matches 0.. run scoreboard players set Gun7 GunVar_BulCount 1
execute unless score Gun8 GunVar_BulCount matches 0.. run scoreboard players set Gun8 GunVar_BulCount 1
execute unless score Gun9 GunVar_BulCount matches 0.. run scoreboard players set Gun9 GunVar_BulCount 2
execute unless score Gun10 GunVar_BulCount matches 0.. run scoreboard players set Gun10 GunVar_BulCount 2
execute unless score Gun11 GunVar_BulCount matches 0.. run scoreboard players set Gun11 GunVar_BulCount 3
execute unless score Gun12 GunVar_BulCount matches 0.. run scoreboard players set Gun12 GunVar_BulCount 1
execute unless score Gun13 GunVar_BulCount matches 0.. run scoreboard players set Gun13 GunVar_BulCount 1
execute unless score Gun14 GunVar_BulCount matches 0.. run scoreboard players set Gun14 GunVar_BulCount 1
execute unless score Gun15 GunVar_BulCount matches 0.. run scoreboard players set Gun15 GunVar_BulCount 1

# The amount of damage each bullet does (0-3)
scoreboard objectives add GunVar_BulDamage dummy
execute unless score Gun1 GunVar_BulDamage matches 0.. run scoreboard players set Gun1 GunVar_BulDamage 2
execute unless score Gun2 GunVar_BulDamage matches 0.. run scoreboard players set Gun2 GunVar_BulDamage 1
execute unless score Gun3 GunVar_BulDamage matches 0.. run scoreboard players set Gun3 GunVar_BulDamage 3
execute unless score Gun4 GunVar_BulDamage matches 0.. run scoreboard players set Gun4 GunVar_BulDamage 1
execute unless score Gun5 GunVar_BulDamage matches 0.. run scoreboard players set Gun5 GunVar_BulDamage 1
execute unless score Gun6 GunVar_BulDamage matches 0.. run scoreboard players set Gun6 GunVar_BulDamage 3
execute unless score Gun7 GunVar_BulDamage matches 0.. run scoreboard players set Gun7 GunVar_BulDamage 2
execute unless score Gun8 GunVar_BulDamage matches 0.. run scoreboard players set Gun8 GunVar_BulDamage 3
execute unless score Gun9 GunVar_BulDamage matches 0.. run scoreboard players set Gun9 GunVar_BulDamage 1
execute unless score Gun10 GunVar_BulDamage matches 0.. run scoreboard players set Gun10 GunVar_BulDamage 1
execute unless score Gun11 GunVar_BulDamage matches 0.. run scoreboard players set Gun11 GunVar_BulDamage 2
execute unless score Gun12 GunVar_BulDamage matches 0.. run scoreboard players set Gun12 GunVar_BulDamage 2
execute unless score Gun13 GunVar_BulDamage matches 0.. run scoreboard players set Gun13 GunVar_BulDamage 1
execute unless score Gun14 GunVar_BulDamage matches 0.. run scoreboard players set Gun14 GunVar_BulDamage 3
execute unless score Gun15 GunVar_BulDamage matches 0.. run scoreboard players set Gun15 GunVar_BulDamage 3

# Bullet direction (1:Straight 2:Disperse)
scoreboard objectives add GunVar_Direction dummy
execute unless score Gun1 GunVar_Direction matches 0.. run scoreboard players set Gun1 GunVar_Direction 2
execute unless score Gun2 GunVar_Direction matches 0.. run scoreboard players set Gun2 GunVar_Direction 1
execute unless score Gun3 GunVar_Direction matches 0.. run scoreboard players set Gun3 GunVar_Direction 1
execute unless score Gun4 GunVar_Direction matches 0.. run scoreboard players set Gun4 GunVar_Direction 1
execute unless score Gun5 GunVar_Direction matches 0.. run scoreboard players set Gun5 GunVar_Direction 1
execute unless score Gun6 GunVar_Direction matches 0.. run scoreboard players set Gun6 GunVar_Direction 1
execute unless score Gun7 GunVar_Direction matches 0.. run scoreboard players set Gun7 GunVar_Direction 1
execute unless score Gun8 GunVar_Direction matches 0.. run scoreboard players set Gun8 GunVar_Direction 1
execute unless score Gun9 GunVar_Direction matches 0.. run scoreboard players set Gun9 GunVar_Direction 1
execute unless score Gun10 GunVar_Direction matches 0.. run scoreboard players set Gun10 GunVar_Direction 1
execute unless score Gun11 GunVar_Direction matches 0.. run scoreboard players set Gun11 GunVar_Direction 1
execute unless score Gun12 GunVar_Direction matches 0.. run scoreboard players set Gun12 GunVar_Direction 1
execute unless score Gun13 GunVar_Direction matches 0.. run scoreboard players set Gun13 GunVar_Direction 1
execute unless score Gun14 GunVar_Direction matches 0.. run scoreboard players set Gun14 GunVar_Direction 2
execute unless score Gun15 GunVar_Direction matches 0.. run scoreboard players set Gun15 GunVar_Direction 1
#----------------CONSTANTS-----------------#
scoreboard players set c2 Constant 2
scoreboard players set c10 Constant 10
scoreboard players set c4 Constant 4
#------------------------------------------#